import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map.Entry;
import java.util.Scanner;

public class g
{
  static Scanner sc = new Scanner (System.in);
  static int A, B, C, N;
  static Cube[] cubes;
  static HashMap < Cube, Integer > cubeMap = new HashMap <> ();
  static int[] DX = { 1, 0, 0, -1, 0, 0 };
  static int[] DY = { 0, 1, 0, 0, -1, 0 };
  static int[] DZ = { 0, 0, 1, 0, 0, -1 };

  public static void main (String[]args)
  {
    A = sc.nextInt ();
    B = sc.nextInt ();
    C = sc.nextInt ();
    N = sc.nextInt ();
    cubes = new Cube[N];
    for (int i = 0; i < N; ++i)
      {
	int X = sc.nextInt ();
	int Y = sc.nextInt ();
	int Z = sc.nextInt ();
	cubes[i] = new Cube (X, Y, Z);
	cubeMap.put (cubes[i], i);
      }
    System.out.println (solve ());
  }

  static int solve ()
  {
    int ans = 1;
    boolean[]used = new boolean[N];
    for (int i = 0; i < N; ++i)
      {
	if (used[i])
	  continue;
	HashMap < Cube, Integer > borderCubes = collect (i, used);
	UnionFind uf = new UnionFind (borderCubes.size ());
	ans += borderCubes.size () - 1;
      for (Entry < Cube, Integer > entry:borderCubes.entrySet ())
	  {
	    Cube c = entry.getKey ();
	    for (int j = 0; j < 6; ++j)
	      {
		int nx = c.x + DX[j];
		int ny = c.y + DY[j];
		int nz = c.z + DZ[j];
		Integer pos = borderCubes.get (new Cube (nx, ny, nz));
		if (pos != null && !uf.find (entry.getValue (), pos))
		  {
		    uf.union (entry.getValue (), pos);
		    --ans;
		  }
	      }
	  }
      }
    return ans;
  }

  static HashMap < Cube, Integer > collect (int startIdx, boolean[]used)
  {
    HashMap < Cube, Integer > ret = new HashMap <> ();
    ArrayDeque < Integer > q = new ArrayDeque <> ();
    q.add (startIdx);
    while (!q.isEmpty ())
      {
	int pos = q.poll ();
	Cube cur = cubes[pos];
	for (int dx = -1; dx <= 1; ++dx)
	  {
	    for (int dy = -1; dy <= 1; ++dy)
	      {
		for (int dz = -1; dz <= 1; ++dz)
		  {
		    if (dx == 0 && dy == 0 && dz == 0)
		      continue;
		    Integer next =
		      cubeMap.
		      get (new Cube (cur.x + dx, cur.y + dy, cur.z + dz));
		    if (next != null && !used[next])
		      {
			q.add (next);
			used[next] = true;
		      }
		    if (next == null
			&& inside (cur.x + dx, cur.y + dy, cur.z + dz))
		      {
			Cube retCube =
			  new Cube (cur.x + dx, cur.y + dy, cur.z + dz);
			if (!ret.containsKey (retCube))
			  {
			    ret.put (retCube, ret.size ());
			  }
		      }
		  }
	      }
	  }
      }
    return ret;
  }

  static boolean inside (int x, int y, int z)
  {
    return 0 <= x && x < A && 0 <= y && y < B && 0 <= z && z < C;
  }

  static class Cube
  {
    int x, y, z;

      Cube (int x, int y, int z)
    {
      this.x = x;
      this.y = y;
      this.z = z;
    }

    public int hashCode ()
    {
      int result = x;
      result = 31 * result + y;
      result = 31 * result + z;
      return result;
    }

    public boolean equals (Object obj)
    {
      Cube o = (Cube) obj;
      return this.x == o.x && this.y == o.y && this.z == o.z;
    }
  }

  static class UnionFind
  {
    int[] set;

      UnionFind (int n)
    {
      set = new int[n];
        Arrays.fill (set, -1);
    }

    void union (int a, int b)
    {
      int rtA = root (a);
      int rtb = root (b);
      if (rtA == rtb)
	{
	  return;
	}
      set[rtA] += set[rtb];
      set[rtb] = rtA;
    }

    boolean find (int a, int b)
    {
      return root (a) == root (b);
    }

    int root (int a)
    {
      if (set[a] < 0)
	{
	  return a;
	}
      else
	{
	  set[a] = root (set[a]);
	  return set[a];
	}
    }

    int size (int a)
    {
      return -set[root (a)];
    }
  }

}
